import tester.*;

// Examples and tests for Books, Songs, Images and lists of Books,
//   Songs, and Images
class Examples{
    Examples(){}

    Book oms = new Book("Old Man and the Sea", "Hemingway", 30);
    Book eos = new Book("Elements of Style", "EBW", 20);
    Book htdp = new Book("HtDP", "MF", 60);
    Book ll = new Book("Little Lisper", "MF", 25);
  
    ILo<Book> mtlob = new MtLo<Book>();
    ILo<Book> blist2 = new ConsLo<Book>(this.oms,
                             new ConsLo<Book>(this.eos, this.mtlob));
    ILo<Book> blist3 = new ConsLo<Book>(this.htdp, this.blist2);
  
    Song help = new Song("Help", "Beatles", 283);
    Song hotelc = new Song("Hotel California", "Eagles", 276);
    Song yesterday = new Song("Yesterday", "Beatles", 195);
  
    ILo<Song> mtlos = new MtLo<Song>();
    ILo<Song> slist2 = new ConsLo<Song>(this.help,
                             new ConsLo<Song>(this.hotelc, this.mtlos));
    ILo<Song> slist3 = new ConsLo<Song>(this.yesterday, this.slist2);
  
    Image beach = new Image("Beach", "jpeg", 24348);
    Image park = new Image("Park", "gif", 33246);
    Image party = new Image("Party", "png", 4532);
 
    ILo<Image> mtloi = new MtLo<Image>();
    ILo<Image> ilist2 = new ConsLo<Image>(this.beach, 
                               new ConsLo<Image>(this.park, this.mtloi));
    ILo<Image> ilist3 = new ConsLo<Image>(this.party, this.ilist2);

    // Test the size method for all lists
    void testSize(Tester t){
        t.checkExpect(mtlob.size(), 0);
        t.checkExpect(blist2.size(), 2);
        t.checkExpect(blist3.size(), 3);

        t.checkExpect(mtlos.size(), 0);
        t.checkExpect(slist2.size(), 2);
        t.checkExpect(slist3.size(), 3);
  
        t.checkExpect(mtloi.size(), 0);
        t.checkExpect(ilist2.size(), 2);
        t.checkExpect(ilist3.size(), 3);
    }
  
    // Test the contains method for all lists
    void testContains(Tester t){
        t.checkExpect(mtlob.size(), 0);
        t.checkExpect(blist2.size(), 2);
        t.checkExpect(blist3.size(), 3);

        t.checkExpect(mtlos.size(), 0);
        t.checkExpect(slist2.size(), 2);
        t.checkExpect(slist3.size(), 3);
  
        t.checkExpect(mtloi.size(), 0);
        t.checkExpect(ilist2.size(), 2);
        t.checkExpect(ilist3.size(), 3);
    }
  
  
    /*
    // Test the totalValue method for all lists
    void testValue(Tester t){
        t.checkExpect(mtlob.totalValue(), 0);
        t.checkExpect(blist2.totalValue(), 50);
        t.checkExpect(blist3.totalValue(), 110);

        t.checkExpect(mtlos.totalValue(), 0);
        t.checkExpect(slist2.totalValue(), 559);
        t.checkExpect(slist3.totalValue(), 754);
  
        t.checkExpect(mtloi.totalValue(), 0);
        t.checkExpect(ilist2.totalValue(), 57594);
        t.checkExpect(ilist3.totalValue(), 62126);
    }
    */
}